<?php

namespace Garradin;

use Garradin\Plugin\RecusFiscaux\RecusHTML;
use Garradin\Plugin\RecusFiscaux\Utils;
use Garradin\Plugin\RecusFiscaux\Personne;

// récupérer les lignes sélectionnées
$lesLignes = f('selected');

// filtrer les versements sélectionnés
$versementsSelectionnes = array();
foreach ($lesLignes as $ligne) {
    $versementsSelectionnes[] = $_SESSION['lesVersementsTotaux'][$ligne];
}

// générer les reçus
$nomAsso = Utils::getNomAsso();
$adresseAsso = Utils::getAdresseAsso();
$signature =
           (null !== $plugin->getConfig('signature')) ?
           \Garradin\Files\Files::get($plugin->getConfig('signature'))->fullpath() :
           "";

// articles du CGI
$articlesCGI = array();
foreach ($plugin->getConfig('articlesCGI') as $article)
{
    if ($article->valeur == 1) {
        $articlesCGI[] = $article->titre;
    }
}
$listeFichiers = array();    // fichiers pdf générés
foreach ($versementsSelectionnes as $ligne)
{
    // générer un fichier par reçu
    $html = new RecusHTML(
        $nomAsso,
        $adresseAsso,
        $plugin->getConfig('objet_asso'),
        $plugin->getConfig('nom_responsable'),
        $plugin->getConfig('fonction_responsable'),
        $plugin->getConfig('ville_asso'),
        $articlesCGI,
        $signature
    );

    // extraire les montants des versements
    $lesMontants[$_SESSION['taux_reduction']] = $ligne->versement/100;
    $personne = $_SESSION['membresDonateurs'][$ligne->idUser];
    $html->imprimer_recu(
        $_SESSION['annee_recu'],
        $personne->id,
        $personne->nomPrenom,
        $lesMontants,
        $personne->adresse,
        $personne->codePostal,
        $personne->ville
    );
    // fabriquer le fichier PDF
    $nomPDF = \Garradin\Utils::filePDF($html->get());
    // changer le nom du fichier
    $nom = str_replace(' ', '_', $personne->nomPrenom);
    $nom = str_replace("'", "", $nom);
    $nomFichier = "recu_" . $_SESSION['annee_recu'] . "_" . $nom . ".pdf";
    rename($nomPDF, $nomFichier);
    // ajouter le nom du fichier à la liste pour mettre dans une archive
    $listeFichiers[] = $nomFichier;
}

// faire une archive zip
$fichierZip = Utils::makeArchive(
    $listeFichiers,
    $_SESSION['annee_recu'],
    PLUGIN_ROOT . "/zip"
);
