<?php

namespace Garradin;

use Garradin\Plugin\RecusFiscaux\Personne;
use Garradin\Plugin\RecusFiscaux\Utils;

// vérifier si l'année a bien été sélectionnée au préalable
$_SESSION['annee_recu'] = f('annee_recu');
if (! isset($_SESSION['annee_recu']) || $_SESSION['annee_recu'] == "") {
    \Garradin\Utils::redirect(PLUGIN_URL . 'index.php');
}
$_SESSION['taux_reduction'] = $_POST['taux_reduction'];

// champs pour le nom et prénom
$confNoms = (array) $plugin->getConfig('nomChamps');
uasort($confNoms, function ($a, $b)
{
    return $a->position - $b->position;
});
$champsNom = array();
foreach ($confNoms as $nom => $champ)
{
    if ($champ->position != 0) { $champsNom[] = $nom; }
}

// versements totaux par personne
$_SESSION['lesVersementsTotaux'] =
                           Utils::getVersementsTotaux($_SESSION['annee_recu'],
                                                      $champsNom);

// membres donateurs
$versementsMembres = Utils::getDonateurs($_SESSION['annee_recu'],
                                         $champsNom);
$membresDonateurs = array();
foreach ($versementsMembres as $versement) {
    $membresDonateurs[$versement->idUser] = new Personne($versement->idUser,
                                                         $versement->nom,
                                                         $versement->adresse,
                                                         $versement->codePostal,
                                                         $versement->ville);
}
$_SESSION['membresDonateurs'] = $membresDonateurs;

// préparation de l'affichage
$tpl->assign('lesVersementsTotaux', $_SESSION['lesVersementsTotaux']);
$tpl->assign('lesDonateurs', $membresDonateurs);
$tpl->assign('plugin_css', ['style.css']);

// envoyer au template
$tpl->display(PLUGIN_ROOT . '/templates/versements_personnes.tpl');
